SystemOrganization addCategory: #'Traits-Composition'!
SystemOrganization addCategory: #'Traits-Kernel'!

!CompiledMethod methodsFor: '*Traits-NanoKernel' stamp: ''!
originalTraitMethod
	^ self properties originalTraitMethod! !

!CompiledMethod methodsFor: '*Traits-NanoKernel' stamp: ''!
originalTraitMethod: t1 
	| t2 |
	t2 := TraitMethodState newFrom: self properties.
	t2 originalTraitMethod: t1.
	self penultimateLiteral: t2! !

!CompiledMethod methodsFor: '*Traits-NanoKernel' stamp: ''!
originalTraitOrClass
	^ self properties originalTraitOrClass! !

!CompiledMethod methodsFor: '*Traits-NanoKernel' stamp: ''!
sameTraitCodeAs: t1 
	| t2 t6 t7 |
	(t1 isKindOf: CompiledMethod)
		ifFalse: [^ false].
	self methodHome == t1 methodHome
		ifFalse: [^ false].
	(self properties analogousCodeTo: t1 properties)
		ifFalse: [^ false].
	self size = t1 size
		ifFalse: [^ false].
	self header = t1 header
		ifFalse: [^ false].
	self initialPC
		to: self endPC
		do: [:t3 | (self at: t3)
					= (t1 at: t3)
				ifFalse: [^ false]].
	(t2 := self numLiterals) ~= t1 numLiterals
		ifTrue: [^ false].
	1
		to: t2 - 2
		do: [:t5 | 
			t6 := self literalAt: t5.
			t7 := t1 literalAt: t5.
			(t6 == t7
					or: [t6 literalEqual: t7])
				ifFalse: [(t5 = 1
							and: [#(117 120 ) includes: self primitive])
						ifTrue: [t6 isArray
								ifTrue: [(t7 isArray
											and: [t6 allButLast = t7 allButLast])
										ifFalse: [^ false]]
								ifFalse: [(t6 analogousCodeTo: t7)
										ifFalse: [^ false]]]
						ifFalse: [^ false]]].
	^ true! !

!AdditionalMethodState methodsFor: '*Traits-NanoKernel' stamp: ''!
originalTraitMethod
	^ nil! !

!AdditionalMethodState methodsFor: '*Traits-NanoKernel' stamp: ''!
originalTraitOrClass
	^ method methodClass! !

AdditionalMethodState variableSubclass: #TraitMethodState
	instanceVariableNames: 'originalTraitMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Kernel'!

!TraitMethodState methodsFor: 'accessing' stamp: ''!
methodHome
	^ originalTraitMethod
		ifNil: [super methodHome]
		ifNotNil: [:t1 | t1 methodHome]! !

!TraitMethodState methodsFor: 'accessing' stamp: ''!
originalTraitMethod
	^ originalTraitMethod! !

!TraitMethodState methodsFor: 'accessing' stamp: ''!
originalTraitMethod: t1 
	originalTraitMethod := t1! !

!TraitMethodState methodsFor: 'accessing' stamp: ''!
originalTraitOrClass
	^ originalTraitMethod originalTraitOrClass! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
allTraits
	^ self traitComposition isEmpty
		ifTrue: [#()]
		ifFalse: [self traitComposition allTraits]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
assembleTraitMethodsFrom: t1 
	| t2 |
	t2 := Dictionary new.
	self
		selectorsAndMethodsDo: [:t3 :t4 | (self isLocalMethod: t4)
				ifTrue: [t2 at: t3 put: t4]].
	t1
		do: [:t3 | t3
				selectorsAndMethodsDo: [:t4 :t5 | 
					| t6 |
					t6 := t2
								at: t4
								ifAbsentPut: [t5].
					t5 == t6
						ifFalse: [(self isLocalMethod: t6)
								ifFalse: [t2
										at: t4
										put: (self
												resolveTraitsConflict: t4
												from: t6
												to: t5)]]]].
	^ t2! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
basicRemoveSelector: t1 
	| t2 |
	t2 := super basicRemoveSelector: t1.
	t2
		ifNotNil: [self updateTraits].
	^ t2! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
classify: t1 under: t2 from: t3 trait: t4 
	self updateTraits! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
hasTraitComposition
	^ self traitComposition notEmpty! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
includesLocalSelector: t1 
	^ (self
		compiledMethodAt: t1
		ifAbsent: [^ false]) methodHome == self! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
includesTrait: t1 
	^ self traitComposition
		anySatisfy: [:t2 | t2 includesTrait: t1]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
installTraitMethodDict: t1 
	| t2 t3 |
	t2 := Set new.
	t1
		keysAndValuesDo: [:t4 :t5 | 
			| t6 |
			t6 := self
						compiledMethodAt: t4
						ifAbsent: [].
			t6 == t5
				ifFalse: [self traitAddSelector: t4 withMethod: t5.
					(self organization categoryOfElement: t4)
						ifNotNil: [:t7 | t2 add: t7].
					self organization
						classify: t4
						under: (t5 methodHome organization categoryOfElement: t5 selector)]].
	t3 := OrderedCollection new.
	self
		selectorsDo: [:t4 | (t1 includesKey: t4)
				ifFalse: [t3 add: t4]].
	t3
		do: [:t4 | self traitRemoveSelector: t4].
	t2
		do: [:t4 | (self organization isEmptyCategoryNamed: t4)
				ifTrue: [self organization removeCategory: t4]]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
installTraitsFrom: t1 
	| t2 t3 |
	(self traitComposition isEmpty
			and: [t1 isEmpty])
		ifTrue: [^ self].
	t2 := t1
				gather: [:t4 | t4 allTraits copyWith: t4].
	(t2 includes: self)
		ifTrue: [^ self error: 'Cyclic trait definition detected'].
	self traitComposition: t1.
	t3 := self assembleTraitMethodsFrom: t1.
	self installTraitMethodDict: t3.
	self isMeta
		ifFalse: [self classSide updateTraitsFrom: t1]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
isAliasSelector: t1 
	^ (self includesLocalSelector: t1) not
		and: [self hasTraitComposition
				and: [self traitComposition isAliasSelector: t1]]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
isLocalAliasSelector: t1 
	^ (self includesLocalSelector: t1) not
		and: [self hasTraitComposition
				and: [self traitComposition isLocalAliasSelector: t1]]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
isLocalMethod: t1 
	^ t1 methodHome == self! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: 'rms 1/13/2013 00:12'!
localSelectors

	^ (self selectors
		select: [:t1 | self includesLocalSelector: t1]) ifEmpty: [^nil]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
recompile: t1 from: t2 
	| t3 |
	t3 := t2 compiledMethodAt: t1.
	super recompile: t1 from: t2.
	t3 originalTraitMethod
		ifNotNil: [:t4 | (self compiledMethodAt: t1)
				originalTraitMethod: t4]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: 'nice 2/23/2011 21:46'!
replaceSelector: originalSelector withAlias: aliasSelector in: source
	"replaces originalSelector with aliasSelector in in given source code"
	| oldKeywords newKeywords args selectorWithArgs s |
	oldKeywords := originalSelector keywords.
	newKeywords := aliasSelector keywords.
	oldKeywords size = newKeywords size ifFalse:[self error: 'Keyword mismatch'].
	args := (self newParser parseArgsAndTemps: source asString notifying: nil) 
				copyFrom: 1 to: originalSelector numArgs.
	selectorWithArgs := String streamContents: [:stream |
		newKeywords keysAndValuesDo: [:index :keyword |
			stream nextPutAll: keyword.
			stream space.
			args size >= index ifTrue: [
				stream nextPutAll: (args at: index); space]]].
	s := source asString readStream.
	oldKeywords do: [ :each | s match: each ].
	args isEmpty ifFalse: [ s match: args last ].
	^selectorWithArgs withBlanksTrimmed asText , s upToEnd
! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
resolveTraitsConflict: t1 from: t2 to: t3 
	| t4 t5 |
	t2 methodHome == t3 methodHome
		ifTrue: [^ t2].
	t4 := t2 markerOrNil.
	(#(#requirement #explicitRequirement #subclassResponsibility #shouldNotImplement ) includes: t4)
		ifTrue: [^ t3].
	t4 := t3 markerOrNil.
	(#(#requirement #explicitRequirement #subclassResponsibility #shouldNotImplement ) includes: t4)
		ifTrue: [^ t2].
	t5 := #(#conflict #conflict: #conflict:with: #conflict:with:with: #conflict:with:with:with: #conflict:with:with:with:with: #conflict:with:with:with:with:with: #conflict:with:with:with:with:with:with: #conflict:with:with:with:with:with:with:with: ) at: t2 numArgs + 1.
	^ TraitDescription class compiledMethodAt: t5! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
setTraitComposition: t1 
	^ self uses: t1! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
setTraitCompositionFrom: t1 
	^ self uses: t1! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: 'nice 2/23/2011 21:39'!
traitAddSelector: selector withMethod: traitMethod
	"Add a method inherited from a trait. 
	Recompiles to avoid sharing and implement aliasing."
	| oldMethod source methodNode newMethod originalSelector |
	oldMethod := self compiledMethodAt: selector ifAbsent:[nil].
	oldMethod ifNotNil:[
		"The following is an important optimization as it prevents exponential
		growth in recompilation. If T1 is used by T2 and T2 by T3 then (without
		this optimization) any change in T1 would cause all methods in T2 to be
		recompiled and each recompilation of a method in T2 would cause T3
		to be fully recompiled. The test eliminates all such situations."
		(oldMethod sameTraitCodeAs: traitMethod) ifTrue:[^oldMethod].
	].
	originalSelector := traitMethod selector.
	source := traitMethod methodClass sourceCodeAt: originalSelector.
	originalSelector == selector ifFalse:[
		"Replace source selectors for aliases"
		source := self replaceSelector: originalSelector withAlias: selector in: source.
	].
	methodNode := self newCompiler
		compile: source in: self classified: nil notifying: nil ifFail:[^nil].
	newMethod := methodNode generate: self defaultMethodTrailer.
	newMethod putSource: source fromParseNode: methodNode inFile: 2
		withPreamble: [:f | f cr; nextPut: $!!; nextChunkPut: 'Trait method'; cr].
	newMethod originalTraitMethod: traitMethod.
	^super addSelectorSilently: selector withMethod: newMethod.! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
traitComposition
	^ self organization traitComposition! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
traitComposition: t1 
	self traitComposition
		do: [:t2 | t2 removeTraitUser: self].
	t1 isEmptyOrNil
		ifTrue: [self organization isTraitOrganizer
				ifTrue: [self
						organization: (ClassOrganizer newFrom: self organization)]]
		ifFalse: [self organization isTraitOrganizer
				ifFalse: [self
						organization: (TraitOrganizer newFrom: self organization)].
			self organization traitComposition: t1.
			t1
				do: [:t2 | t2 addTraitUser: self]]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
traitCompositionString
	^ self traitComposition isEmpty
		ifTrue: ['{}']
		ifFalse: [self traitComposition asString]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
traitRemoveSelector: t1 
	| t2 t3 |
	t2 := self
				compiledMethodAt: t1
				ifAbsent: [^ nil].
	t3 := self whichCategoryIncludesSelector: t1.
	SystemChangeNotifier uniqueInstance
		doSilently: [self organization removeElement: t1].
	super basicRemoveSelector: t1.
	SystemChangeNotifier uniqueInstance
		methodRemoved: t2
		selector: t1
		inProtocol: t3
		class: self.
	(self organization isEmptyCategoryNamed: t3)
		ifTrue: [self organization removeCategory: t3]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
traits
	^ self traitComposition asArray
		collect: [:t1 | t1 trait]! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
updateTraits
	self installTraitsFrom: self traitComposition! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
updateTraitsFrom: t1 
	| t2 t3 |
	self isMeta
		ifFalse: [self error: 'This is a metaclass operation'].
	t2 := Dictionary new.
	self traitComposition
		do: [:t4 | t2 at: t4 trait put: t4].
	t3 := (t1
				collect: [:t4 | 
					| t5 |
					t5 := t4 trait classTrait.
					t2
						at: t5
						ifAbsent: [t5]])
				, (self traitComposition
						select: [:t4 | t4 trait isBaseTrait]).
	self installTraitsFrom: t3! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
users
	^ #()! !

!ClassDescription methodsFor: '*Traits-NanoKernel' stamp: ''!
uses: t1 
	self installTraitsFrom: t1 asTraitComposition! !

ClassDescription subclass: #TraitBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Kernel'!

TraitBehavior subclass: #TraitDescription
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Kernel'!

TraitDescription subclass: #ClassTrait
	instanceVariableNames: 'baseTrait'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Kernel'!

!ClassTrait class methodsFor: 'instance creation' stamp: ''!
for: t1 
	^ self new baseTrait: t1! !

!ClassTrait methodsFor: 'monticello' stamp: ''!
asMCDefinition
	^ Smalltalk
		at: #MCClassTraitDefinition
		ifPresent: [:t1 | t1 baseTraitName: self baseTrait name classTraitComposition: self traitCompositionString]! !

!ClassTrait methodsFor: 'accessing' stamp: ''!
baseTrait
	^ baseTrait! !

!ClassTrait methodsFor: 'accessing' stamp: ''!
baseTrait: t1 
	baseTrait
		ifNotNil: [self error: 'Already initialized'].
	baseTrait := t1! !

!ClassTrait methodsFor: 'compiling' stamp: ''!
bindingOf: t1 
	^ baseTrait bindingOf: t1! !

!ClassTrait methodsFor: 'accessing' stamp: 'nice 2/15/2011 23:16'!
category
	"Answer the category used for classifying this ClassTrait.
	The category is shared between a Trait and its associated ClassTrait."
	
	^baseTrait category! !

!ClassTrait methodsFor: 'accessing' stamp: ''!
definition
	^ String
		streamContents: [:t1 | 
			t1 nextPutAll: self name.
			t1 cr; tab; nextPutAll: 'uses: '; nextPutAll: self traitComposition asString]! !

!ClassTrait methodsFor: 'accessing' stamp: ''!
instanceSide
	^ self baseTrait! !

!ClassTrait methodsFor: 'testing' stamp: ''!
isClassTrait
	^ true! !

!ClassTrait methodsFor: 'testing' stamp: ''!
isMeta
	^ true! !

!ClassTrait methodsFor: 'testing' stamp: ''!
isObsolete
	^ baseTrait
		ifNil: [true]
		ifNotNil: [baseTrait isObsolete]! !

!ClassTrait methodsFor: 'accessing' stamp: ''!
name
	^ baseTrait name , ' classTrait'! !

!ClassTrait methodsFor: 'accessing' stamp: ''!
soleInstance
	^ baseTrait! !

!ClassTrait methodsFor: 'accessing' stamp: ''!
theMetaClass
	^ self! !

!ClassTrait methodsFor: 'accessing' stamp: ''!
theNonMetaClass
	^ baseTrait! !

!ClassTrait methodsFor: 'initialize' stamp: ''!
uses: t1 
	| t2 t3 |
	t3 := self shallowCopy.
	t2 := t1 asTraitComposition.
	t2
		traitsDo: [:t4 | 
			(t4 isBaseTrait
					and: [t4 classSide hasMethods])
				ifTrue: [self error: 'Cannot add: ' , t4].
			(t4 isClassTrait
					and: [(baseTrait includesTrait: t4 baseTrait) not])
				ifTrue: [self error: 'Cannot add: ' , t4]].
	self installTraitsFrom: t2.
	SystemChangeNotifier uniqueInstance traitDefinitionChangedFrom: t3 to: self! !

TraitDescription subclass: #Trait
	instanceVariableNames: 'name environment classTrait category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Kernel'!

!Trait class methodsFor: 'public' stamp: 'ul 9/28/2012 10:29'!
allTraitsDo: aBlock
	"Evaluate aBlock with all the instance and class traits present in the system"
	
	Smalltalk allTraitsDo: [ :aTrait |
		aBlock
			value: aTrait instanceSide;
			value: aTrait classSide ]! !

!Trait class methodsFor: 'load-unload' stamp: ''!
convertClassToTrait: t1 
	| t2 |
	t1 environment removeKey: t1 name.
	t2 := Trait
				named: t1 name
				uses: {}
				category: t1 category.
	t1 organization commentRemoteStr
		ifNotNil: [t2 classComment: t1 organization classComment stamp: t1 organization commentStamp].
	t1
		selectorsAndMethodsDo: [:t3 :t4 | t2
				compile: (t1 sourceCodeAt: t3)
				classified: (t1 organization categoryOfElement: t3)
				withStamp: (t1 compiledMethodAt: t3) timeStamp
				notifying: nil].
	t1 classSide
		selectorsAndMethodsDo: [:t3 :t4 | t2 classSide
				compile: (t1 classSide sourceCodeAt: t3)
				classified: (t1 classSide organization categoryOfElement: t3)
				withStamp: (t1 classSide compiledMethodAt: t3) timeStamp
				notifying: nil].
	t1 obsolete.
	^ t2! !

!Trait class methodsFor: 'load-unload' stamp: ''!
convertTraitToClass: t1 
	| t2 |
	t1 environment removeKey: t1 name.
	t2 := Object
				subclass: t1 name
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: t1 category.
	t1 organization commentRemoteStr
		ifNotNil: [t2 classComment: t1 organization classComment stamp: t1 organization commentStamp].
	t1
		selectorsAndMethodsDo: [:t3 :t4 | t2
				compile: (t1 sourceCodeAt: t3)
				classified: (t1 organization categoryOfElement: t3)
				withStamp: (t1 compiledMethodAt: t3) timeStamp
				notifying: nil].
	t1 classSide
		selectorsAndMethodsDo: [:t3 :t4 | t2 classSide
				compile: (t1 classSide sourceCodeAt: t3)
				classified: (t1 classSide organization categoryOfElement: t3)
				withStamp: (t1 classSide compiledMethodAt: t3) timeStamp
				notifying: nil].
	t1 obsolete.
	^ t2! !

!Trait class methodsFor: 'load-unload' stamp: ''!
flattenTraitMethodsInClass: t1 
	(t1 isTrait
			or: [t1 hasTraitComposition])
		ifFalse: [^ self].
	self storeTraitInfoInClass: t1.
	t1
		selectorsAndMethodsDo: [:t2 :t3 | | t4 | (t1 includesLocalSelector: t2)
				ifFalse: [t4 := t3 methodHome.
					t1
						compile: (t1 sourceCodeAt: t2)
						classified: (t1 organization categoryOfElement: t2)
						withStamp: (t4
								compiledMethodAt: t2
								ifAbsent: [t3]) timeStamp
						notifying: nil]].
	t1 traitComposition: #()! !

!Trait class methodsFor: 'load-unload' stamp: ''!
initialize
	self install! !

!Trait class methodsFor: 'load-unload' stamp: ''!
install
	ClassDescription traitImpl: self.
	self restoreAllTraits! !

!Trait class methodsFor: 'public' stamp: ''!
named: t1 uses: t2 category: t3 
	^ ClassDescription
		newTraitNamed: t1
		uses: t2
		category: t3! !

!Trait class methodsFor: 'instance creation' stamp: ''!
named: t1 uses: t2 category: t3 env: t4 
	| t5 t6 t7 |
	t7 := t3 asSymbol.
	t5 := t4
				at: t1
				ifAbsent: [].
	(t5
			ifNil: [true]
			ifNotNil: [t5 isMemberOf: Trait])
		ifFalse: [^ self error: t5 name , ' is not a Trait'].
	t6 := t5 shallowCopy.
	t5
		ifNil: [t5 := Trait new].
	t5
		setName: t1
		andRegisterInCategory: t7
		environment: t4.
	t5 uses: t2.
	t6
		ifNil: [SystemChangeNotifier uniqueInstance classAdded: t5 inCategory: t7]
		ifNotNil: [SystemChangeNotifier uniqueInstance traitDefinitionChangedFrom: t6 to: t5.
			t7 = t6 category
				ifFalse: [SystemChangeNotifier uniqueInstance
						class: t5
						recategorizedFrom: t6 category
						to: t7]].
	^ t5! !

!Trait class methodsFor: 'public' stamp: ''!
newTemplateIn: t1 
	^ String
		streamContents: [:t2 | t2 nextPutAll: 'Trait named: #NameOfTrait';
				 cr;
				 tab;
				 nextPutAll: 'uses: {}';
				 cr;
				 tab;
				 nextPutAll: 'category: ';
				 nextPut: $';
				 nextPutAll: t1;
				 nextPut: $']! !

!Trait class methodsFor: 'public' stamp: ''!
newTraitComposition
	^ TraitComposition new! !

!Trait class methodsFor: 'public' stamp: ''!
newTraitNamed: t1 uses: t2 category: t3 
	| t4 |
	t4 := self environment.
	^ self
		named: t1
		uses: t2
		category: t3
		env: t4! !

!Trait class methodsFor: 'load-unload' stamp: ''!
removeAllTraits
	| t1 t2 |
	t1 := Set new.
	Smalltalk allClasses
		do: [:t3 | 
			self flattenTraitMethodsInClass: t3 classSide.
			self flattenTraitMethodsInClass: t3.
			t1 add: t3]
		displayingProgress: 'Flattening classes'.
	t2 := Smalltalk allTraits asSet.
	(1 to: t2 size)
		do: [:t3 | 
			| t4 |
			t4 := t2
						detect: [:t5 | t5 users
								allSatisfy: [:t6 | t1 includes: t6]]
						ifNone: [self error: 'Cyclic traits detected'].
			t2 remove: t4.
			self flattenTraitMethodsInClass: t4 classSide.
			self flattenTraitMethodsInClass: t4.
			t1 add: t4]
		displayingProgress: 'Flattening traits'.
	Smalltalk allTraits
		do: [:t3 | self convertTraitToClass: t3]
		displayingProgress: [:t3 | 'Converting ' , t3 name]! !

!Trait class methodsFor: 'load-unload' stamp: ''!
restoreAllTraits
	| t1 |
	t1 := Smalltalk allClasses
				select: [:t2 | t2 includesSelector: #traitInfo].
	t1
		do: [:t2 | 
			| t3 |
			t3 := t2 compiledMethodAt: #traitInfo.
			(t3 pragmaAt: #traitDefinition:)
				ifNotNil: [:t4 | t4 arguments first
						ifTrue: [self convertClassToTrait: t2]]]
		displayingProgress: [:t2 | 'Creating trait ' , t2 name].
	t1 := Smalltalk allClassesAndTraits
				select: [:t2 | (t2 includesSelector: #traitInfo)
						or: [t2 classSide includesSelector: #traitInfo]].
	t1
		do: [:t2 | 
			self restoreCompositionOf: t2.
			self restoreCompositionOf: t2 classSide]
		displayingProgress: [:t2 | 'Updating ' , t2 name]! !

!Trait class methodsFor: 'load-unload' stamp: ''!
restoreCompositionOf: t1 
	| t2 t3 t4 t6 |
	t2 := t1
				compiledMethodAt: #traitInfo
				ifAbsent: [^ self].
	t1 removeSelector: #traitInfo.
	t3 := (t2 pragmaAt: #traitRequires:)
				ifNil: [#()]
				ifNotNil: [:t5 | t5 arguments first].
	(t3
			allSatisfy: [:t7 | (Smalltalk
					at: t7
					ifAbsent: [])
					isKindOf: Trait])
		ifFalse: [^ self inform: 'Cannot restore composition of ' , t1 name].
	(t6 := t2 pragmaAt: #traitComposition:)
		ifNil: [^ self].
	t4 := Compiler evaluate: t6 arguments first.
	t1 uses: t4.
	t1 traitComposition
		selectorsAndMethodsDo: [:t7 :t8 | 
			| t9 t10 |
			t10 := t8 methodHome compiledMethodAt: t7.
			t9 := t1
						compiledMethodAt: t7
						ifAbsent: [t10].
			t9 timeStamp = t10 timeStamp
				ifTrue: [t1 removeSelector: t7]]! !

!Trait class methodsFor: 'load-unload' stamp: ''!
storeTraitInfoInClass: t1 
	| t2 |
	t2 := WriteStream
				on: (String new: 100).
	t2 nextPutAll: 'traitInfo
	"This method contains information to restore the trait structure
	for the receiver when traits are loaded or unloaded"'.
	t1 isTrait
		ifTrue: [t2 crtab; nextPutAll: '"This class was originally a trait"'.
			t2 crtab; nextPutAll: '<traitDefinition: true>'].
	t1 hasTraitComposition
		ifTrue: [t2 crtab; nextPutAll: '"The trait composition for the receiver"'.
			t2 crtab; nextPutAll: '<traitComposition: ' , t1 traitCompositionString storeString , '>'.
			t2 crtab; nextPutAll: '"The required traits for this trait"'.
			t2 crtab; nextPutAll: '<traitRequires: '
					, (t1 traits
							collect: [:t3 | t3 baseTrait name]) , '>'].
	t1 compile: t2 contents! !

!Trait class methodsFor: 'load-unload' stamp: ''!
unloadTraits
	Trait traitImpl == self
		ifTrue: [Trait traitImpl: nil].
	self removeAllTraits.
	Behavior compileSilently: 'updateTraits' classified: 'accessing'.
	ClassDescription removeSelectorSilently: #updateTraits.
	ClassOrganizer organization classify: #traitComposition under: 'accessing'.
	(MCPackage named: 'Traits') unload.
	ClassOrganizer removeSelectorSilently: #traitComposition.
	Behavior removeSelectorSilently: #updateTraits.
	Compiler recompileAll! !

!Trait methodsFor: 'monticello' stamp: ''!
asClassDefinition
	^ Smalltalk
		at: #MCTraitDefinition
		ifPresent: [:t1 | t1
				name: self name
				traitComposition: self traitCompositionString
				category: self category
				comment: self organization classComment asString
				commentStamp: self organization commentStamp]! !

!Trait methodsFor: 'converting' stamp: ''!
asTraitComposition
	^ TraitComposition with: self! !

!Trait methodsFor: 'accessing' stamp: ''!
baseTrait
	^ self! !

!Trait methodsFor: 'compiling' stamp: ''!
bindingOf: t1 
	^ self environment bindingOf: t1 asSymbol! !

!Trait methodsFor: 'accessing' stamp: ''!
category
	| t1 |
	category
		ifNotNilDo: [:t2 | 
			((SystemOrganization listAtCategoryNamed: t2)
					includes: self name)
				ifTrue: [^ t2].
			nil].
	category := t1 := SystemOrganization categoryOfElement: self name.
	^ t1! !

!Trait methodsFor: 'accessing' stamp: ''!
category: t1 
	| t2 |
	t2 := category.
	t1 isString
		ifTrue: [category := t1 asSymbol.
			SystemOrganization classify: self name under: category]
		ifFalse: [self errorCategoryName].
	SystemChangeNotifier uniqueInstance
		class: self
		recategorizedFrom: t2
		to: category! !

!Trait methodsFor: 'monticello' stamp: ''!
classDefinitions
	| t1 |
	t1 := OrderedCollection with: self asClassDefinition.
	(self hasClassTrait
			and: [self classTrait hasTraitComposition
					and: [self classTrait traitComposition isEmpty not]])
		ifTrue: [t1 add: self classTrait asMCDefinition].
	^ t1 asArray! !

!Trait methodsFor: 'accessing' stamp: ''!
classTrait
	^ classTrait! !

!Trait methodsFor: 'initialize' stamp: ''!
definition
	^ String
		streamContents: [:t1 | 
			t1 nextPutAll: 'Trait named: ';
				 store: self name.
			t1 cr; tab; nextPutAll: 'uses: '; nextPutAll: self traitComposition asString.
			t1 cr; tab; nextPutAll: 'category: '; store: self category asString]! !

!Trait methodsFor: 'accessing' stamp: ''!
environment
	^ environment! !

!Trait methodsFor: 'accessing' stamp: ''!
environment: t1 
	environment := t1! !

!Trait methodsFor: 'fileIn/Out' stamp: ''!
fileOutOn: t1 moveSource: t2 toFile: t3 
	super
		fileOutOn: t1
		moveSource: t2
		toFile: t3.
	self classSide hasMethods
		ifTrue: [t1 cr; nextPutAll: '"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!'; cr; cr.
			self classSide
				fileOutOn: t1
				moveSource: t2
				toFile: t3]! !

!Trait methodsFor: 'testing' stamp: ''!
hasClassTrait
	^ true! !

!Trait methodsFor: 'initialize' stamp: ''!
initialize
	super initialize.
	classTrait := ClassTrait for: self! !

!Trait methodsFor: 'testing' stamp: ''!
isBaseTrait
	^ true! !

!Trait methodsFor: 'testing' stamp: ''!
isObsolete
	^ (self environment
		at: name
		ifAbsent: [])
		~~ self! !

!Trait methodsFor: 'initialize' stamp: ''!
isValidTraitName: t1 
	^ (t1 isEmptyOrNil
		or: [t1 first isLetter not
				or: [t1
						anySatisfy: [:t2 | t2 isAlphaNumeric not]]]) not! !

!Trait methodsFor: 'accessing' stamp: ''!
name
	^ name! !

!Trait methodsFor: 'accessing' stamp: ''!
name: t1 
	name := t1! !

!Trait methodsFor: 'initialize' stamp: ''!
obsolete
	self name: ('AnObsolete' , self name) asSymbol.
	self classTrait obsolete.
	super obsolete! !

!Trait methodsFor: 'initialize' stamp: ''!
removeFromSystem
	self removeFromSystem: true! !

!Trait methodsFor: 'initialize' stamp: ''!
removeFromSystem: t1 
	self environment forgetClass: self logged: t1.
	self obsolete! !

!Trait methodsFor: 'initialize' stamp: ''!
rename: t1 
	| t2 |
	(t2 := t1 asSymbol) ~= self name
		ifFalse: [^ self].
	(self environment includesKey: t2)
		ifTrue: [^ self error: t2 , ' already exists'].
	(Undeclared includesKey: t2)
		ifTrue: [self inform: 'There are references to, ' , t1 printString , '
from Undeclared. Check them after this change.'].
	self environment renameClass: self as: t2.
	name := t2! !

!Trait methodsFor: 'initialize' stamp: ''!
setName: t1 andRegisterInCategory: t2 environment: t3 
	(self isValidTraitName: t1)
		ifFalse: [self error: 'Invalid trait name'].
	(self environment == t3
			and: [self name = t1
					and: [self category = t2]])
		ifTrue: [^ self].
	((t3 includesKey: t1)
			and: [(t3 at: t1)
					~~ self])
		ifTrue: [self error: 'The name ''' , t1 , ''' is already used'].
	(self environment notNil
			and: [self name notNil
					and: [self name ~= t1]])
		ifTrue: [self environment renameClass: self as: t1].
	self name: t1.
	self environment: t3.
	self environment at: self name put: self.
	self environment organization classify: self name under: t2.
	^ true! !

!Trait methodsFor: 'accessing' stamp: ''!
theMetaClass
	^ self classTrait! !

!TraitDescription class methodsFor: 'conflict methods' stamp: ''!
conflict
	^ self traitConflict! !

!TraitDescription class methodsFor: 'conflict methods' stamp: ''!
conflict: t1 
	^ self traitConflict! !

!TraitDescription class methodsFor: 'conflict methods' stamp: ''!
conflict: t1 with: t2 
	^ self traitConflict! !

!TraitDescription class methodsFor: 'conflict methods' stamp: ''!
conflict: t1 with: t2 with: t3 
	^ self traitConflict! !

!TraitDescription class methodsFor: 'conflict methods' stamp: ''!
conflict: t1 with: t2 with: t3 with: t4 
	^ self traitConflict! !

!TraitDescription class methodsFor: 'conflict methods' stamp: ''!
conflict: t1 with: t2 with: t3 with: t4 with: t5 
	^ self traitConflict! !

!TraitDescription class methodsFor: 'conflict methods' stamp: ''!
conflict: t1 with: t2 with: t3 with: t4 with: t5 with: t6 
	^ self traitConflict! !

!TraitDescription class methodsFor: 'conflict methods' stamp: ''!
conflict: t1 with: t2 with: t3 with: t4 with: t5 with: t6 with: t7 
	^ self traitConflict! !

!TraitDescription class methodsFor: 'conflict methods' stamp: ''!
conflict: t1 with: t2 with: t3 with: t4 with: t5 with: t6 with: t7 with: t8 
	^ self traitConflict! !

!TraitDescription methodsFor: 'operations' stamp: ''!
+ t1 
	t1
		traitsDo: [:t2 | self == t2
				ifTrue: [TraitCompositionException signal: 'Trait ' , self asString , ' already in composition']].
	^ TraitComposition withAll: {self} , t1 asTraitComposition! !

!TraitDescription methodsFor: 'operations' stamp: ''!
- t1 
	^ TraitExclusion with: self exclusions: t1! !

!TraitDescription methodsFor: 'operations' stamp: ''!
@ t1 
	^ TraitAlias with: self aliases: t1! !

!TraitDescription methodsFor: 'operations' stamp: ''!
addSelectorSilently: t1 withMethod: t2 
	super addSelectorSilently: t1 withMethod: t2.
	self users
		do: [:t3 | t3 updateTraits]! !

!TraitDescription methodsFor: 'accessing' stamp: ''!
addTraitUser: t1 
	users := self users copyWith: t1! !

!TraitDescription methodsFor: 'accessing' stamp: ''!
allClassVarNames
	^ #()! !

!TraitDescription methodsFor: 'converting' stamp: ''!
asTraitComposition
	^ TraitComposition with: self! !

!TraitDescription methodsFor: 'accessing' stamp: ''!
classPool
	^ Dictionary new! !

!TraitDescription methodsFor: 'copying' stamp: ''!
copy
	self error: 'Traits cannot be trivially copied'! !

!TraitDescription methodsFor: 'copying' stamp: ''!
copyTraitExpression
	^ self! !

!TraitDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOut
	^ self fileOutAsHtml: false! !

!TraitDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutAsHtml: t1 
	| t2 |
	t2 := WriteStream
				on: (String new: 100).
	t2 header; timeStamp.
	self
		fileOutOn: t2
		moveSource: false
		toFile: 0.
	t2 trailer.
	FileStream
		writeSourceCodeFrom: t2
		baseName: self name
		isSt: true
		useHtml: t1! !

!TraitDescription methodsFor: 'testing' stamp: ''!
includesTrait: t1 
	^ self == t1
		or: [super includesTrait: t1]! !

!TraitDescription methodsFor: 'operations' stamp: ''!
installTraitsFrom: t1 
	super installTraitsFrom: t1.
	self users
		do: [:t2 | t2 updateTraits]! !

!TraitDescription methodsFor: 'testing' stamp: ''!
isBaseTrait
	^ false! !

!TraitDescription methodsFor: 'testing' stamp: ''!
isClassTrait
	^ false! !

!TraitDescription methodsFor: 'testing' stamp: ''!
isTrait
	^ true! !

!TraitDescription methodsFor: 'testing' stamp: ''!
isTraitTransformation
	^ false! !

!TraitDescription methodsFor: 'operations' stamp: ''!
notifyOfRecategorizedSelector: t1 from: t2 to: t3 
	super
		notifyOfRecategorizedSelector: t1
		from: t2
		to: t3.
	self users
		do: [:t4 | t4
				classify: t1
				under: t3
				from: t2
				trait: self]! !

!TraitDescription methodsFor: 'printing' stamp: ''!
printHierarchy
	^ String
		streamContents: [:t1 | self
				printUsersOf: self
				on: t1
				level: 0]! !

!TraitDescription methodsFor: 'printing' stamp: ''!
printUsersOf: t1 on: t2 level: t3 
	t2 crtab: t3.
	t2 nextPutAll: t1 name.
	t1 isTrait
		ifTrue: [t1 users
				do: [:t4 | self
						printUsersOf: t1
						on: t2
						level: t3 + 1]]! !

!TraitDescription methodsFor: 'accessing' stamp: ''!
removeTraitUser: t1 
	users := self users copyWithout: t1! !

!TraitDescription methodsFor: 'accessing' stamp: ''!
sharedPools
	^ Dictionary new! !

!TraitDescription methodsFor: 'accessing' stamp: ''!
trait
	^ self! !

!TraitDescription methodsFor: 'operations' stamp: ''!
traitsDo: t1 
	t1 value: self! !

!TraitDescription methodsFor: 'accessing' stamp: ''!
users
	^ users
		ifNil: [#()]! !

!TraitDescription methodsFor: 'accessing' stamp: ''!
users: t1 
	users := t1! !

!ClassOrganizer methodsFor: '*Traits-Kernel' stamp: ''!
isTraitOrganizer
	^ false! !

!ClassOrganizer methodsFor: '*Traits-Kernel' stamp: ''!
traitComposition
	^ #()! !

ClassOrganizer subclass: #TraitOrganizer
	instanceVariableNames: 'traitComposition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Kernel'!

!TraitOrganizer methodsFor: 'testing' stamp: ''!
isTraitOrganizer
	^ true! !

!TraitOrganizer methodsFor: 'accessing' stamp: ''!
traitComposition
	^ traitComposition
		ifNil: [traitComposition := TraitComposition new]! !

!TraitOrganizer methodsFor: 'accessing' stamp: ''!
traitComposition: t1 
	traitComposition := t1! !

!SequenceableCollection methodsFor: '*Traits' stamp: ''!
asTraitComposition
	^ self isEmpty
		ifTrue: [ClassDescription newTraitComposition]
		ifFalse: [self size = 1
				ifTrue: [self first asTraitComposition]
				ifFalse: [self copyWithoutFirst
						inject: self first
						into: [:t1 :t2 | t1 + t2]]]! !

Error subclass: #TraitCompositionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Composition'!

Object subclass: #TraitTransformation
	instanceVariableNames: 'subject users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Composition'!

TraitTransformation subclass: #TraitAlias
	instanceVariableNames: 'aliases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Composition'!

!TraitAlias class methodsFor: 'instance creation' stamp: ''!
assertValidAliasDefinition: t1 
	((t1 isKindOf: Collection)
			and: [t1
					allSatisfy: [:t2 | t2 isKindOf: Association]])
		ifFalse: [self error: 'Invalid alias definition: Not a collection of associations.'].
	(t1
			allSatisfy: [:t2 | t2 key numArgs = t2 value numArgs
					and: [(t2 key numArgs = -1) not]])
		ifFalse: [TraitCompositionException signal: 'Invalid alias definition: Alias and original selector have to have the same number of arguments.']! !

!TraitAlias class methodsFor: 'instance creation' stamp: ''!
with: t1 aliases: t2 
	self assertValidAliasDefinition: t2.
	^ self new subject: t1;
		 initializeFrom: t2;
		 yourself! !

!TraitAlias methodsFor: 'converting' stamp: ''!
- t1 
	^ TraitExclusion with: self exclusions: t1! !

!TraitAlias methodsFor: 'converting' stamp: ''!
@ t1 
	^ TraitAlias with: subject aliases: t1 , self aliases! !

!TraitAlias methodsFor: 'accessing' stamp: ''!
aliases
	^ aliases! !

!TraitAlias methodsFor: 'accessing' stamp: ''!
aliases: t1 
	aliases := t1! !

!TraitAlias methodsFor: 'operations' stamp: ''!
copyTraitExpression
	^ TraitAlias with: subject aliases: aliases! !

!TraitAlias methodsFor: 'operations' stamp: ''!
includesSelector: t1 
	^ (subject includesSelector: t1)
		or: [aliases
				anySatisfy: [:t2 | t2 key == t1]]! !

!TraitAlias methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	aliases := #()! !

!TraitAlias methodsFor: 'initialize-release' stamp: ''!
initializeFrom: t1 
	| t2 |
	t2 := (t1
				collect: [:t3 | t3 key]) asIdentitySet.
	t2 size < t1 size
		ifTrue: [TraitCompositionException signal: 'Cannot use the same alias name twice'].
	t1
		do: [:t3 | (t2 includes: t3 value)
				ifTrue: [TraitCompositionException signal: 'Cannot define an alias for an alias']].
	aliases := t1! !

!TraitAlias methodsFor: 'testing' stamp: ''!
isAliasSelector: t1 
	^ (self isLocalAliasSelector: t1)
		or: [super isAliasSelector: t1]! !

!TraitAlias methodsFor: 'testing' stamp: ''!
isLocalAliasSelector: t1 
	^ aliases
		anySatisfy: [:t2 | t2 key == t1]! !

!TraitAlias methodsFor: 'operations' stamp: ''!
printOn: t1 
	t1 nextPutAll: subject asString.
	t1 nextPutAll: ' @ {'.
	aliases
		do: [:t2 | t1 print: t2]
		separatedBy: [t1 nextPutAll: '. '].
	t1 nextPutAll: '}'! !

!TraitAlias methodsFor: 'operations' stamp: 'ul 8/2/2011 20:12'!
selectorsAndMethodsDo: aBlock
	"enumerates all selectors and methods in a trait composition"

	subject selectorsAndMethodsDo: aBlock.
	aliases do:[:assoc| | method |
		"Method can be nil during removals"
		method := subject compiledMethodAt: assoc value ifAbsent:[nil].
		method ifNotNil:[aBlock value: assoc key value: method].
	].! !

TraitTransformation subclass: #TraitExclusion
	instanceVariableNames: 'exclusions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Composition'!

!TraitExclusion class methodsFor: 'instance creation' stamp: ''!
with: t1 exclusions: t2 
	^ self new subject: t1;
		 exclusions: t2;
		 yourself! !

!TraitExclusion methodsFor: 'converting' stamp: ''!
- t1 
	^ TraitExclusion with: subject exclusions: t1 , exclusions asArray! !

!TraitExclusion methodsFor: 'converting' stamp: ''!
@ t1 
	TraitCompositionException signal: 'Invalid trait exclusion. Aliases have to be specified before exclusions.'! !

!TraitExclusion methodsFor: 'composition' stamp: ''!
copyTraitExpression
	^ TraitExclusion with: subject exclusions: exclusions asArray! !

!TraitExclusion methodsFor: 'accessing' stamp: ''!
exclusions
	^ exclusions! !

!TraitExclusion methodsFor: 'accessing' stamp: ''!
exclusions: t1 
	exclusions := Set withAll: t1! !

!TraitExclusion methodsFor: 'composition' stamp: ''!
includesSelector: t1 
	^ (subject includesSelector: t1)
		and: [(exclusions includes: t1) not]! !

!TraitExclusion methodsFor: 'initialize' stamp: ''!
initialize
	super initialize.
	exclusions := Set new! !

!TraitExclusion methodsFor: 'composition' stamp: ''!
printOn: t1 
	t1 nextPutAll: subject asString.
	t1 nextPutAll: ' - {'.
	exclusions asArray sort
		do: [:t2 | t1 store: t2]
		separatedBy: [t1 nextPutAll: '. '].
	t1 nextPutAll: '}'! !

!TraitExclusion methodsFor: 'composition' stamp: ''!
selectorsAndMethodsDo: t1 
	^ subject
		selectorsAndMethodsDo: [:t2 :t3 | (exclusions includes: t2)
				ifFalse: [t1 value: t2 value: t3]]! !

!TraitTransformation methodsFor: 'converting' stamp: ''!
+ t1 
	^ TraitComposition withAll: {self. t1}! !

!TraitTransformation methodsFor: 'converting' stamp: ''!
- t1 
	^ self subclassResponsibility! !

!TraitTransformation methodsFor: 'converting' stamp: ''!
@ t1 
	^ self subclassResponsibility! !

!TraitTransformation methodsFor: 'accessing' stamp: ''!
addTraitUser: t1 
	users := users copyWith: t1.
	subject addTraitUser: t1! !

!TraitTransformation methodsFor: 'accessing' stamp: ''!
allTraits
	^ subject allTraits! !

!TraitTransformation methodsFor: 'converting' stamp: ''!
asTraitComposition
	^ TraitComposition with: self! !

!TraitTransformation methodsFor: 'converting' stamp: ''!
asTraitTransform
	^ self! !

!TraitTransformation methodsFor: 'operations' stamp: ''!
copyTraitExpression
	^ self subclassResponsibility! !

!TraitTransformation methodsFor: 'testing' stamp: ''!
includesTrait: t1 
	^ subject includesTrait: t1! !

!TraitTransformation methodsFor: 'initialize' stamp: ''!
initialize
	super initialize.
	users := #()! !

!TraitTransformation methodsFor: 'testing' stamp: ''!
isAliasSelector: t1 
	^ subject isAliasSelector: t1! !

!TraitTransformation methodsFor: 'testing' stamp: ''!
isLocalAliasSelector: t1 
	^ false! !

!TraitTransformation methodsFor: 'testing' stamp: ''!
isTraitTransformation
	^ true! !

!TraitTransformation methodsFor: 'accessing' stamp: ''!
removeTraitUser: t1 
	users := users copyWithout: t1.
	subject removeTraitUser: t1! !

!TraitTransformation methodsFor: 'operations' stamp: ''!
selectorsAndMethodsDo: t1 
	^ self subclassResponsibility! !

!TraitTransformation methodsFor: 'accessing' stamp: ''!
subject: t1 
	subject := t1! !

!TraitTransformation methodsFor: 'accessing' stamp: ''!
trait
	^ subject trait! !

!TraitTransformation methodsFor: 'accessing' stamp: ''!
traitsDo: t1 
	^ subject traitsDo: t1! !

!TraitTransformation methodsFor: 'operations' stamp: ''!
updateSelector: t1 withTraitMethod: t2 from: t3 
	^ self subclassResponsibility! !

!TraitTransformation methodsFor: 'operations' stamp: ''!
updateTraits
	users
		do: [:t1 | t1 updateTraits]! !

OrderedCollection subclass: #TraitComposition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traits-Composition'!

!TraitComposition methodsFor: 'converting' stamp: ''!
+ t1 
	self
		traitsDo: [:t2 | 
			t2 == t1 trait
				ifTrue: [^ TraitCompositionException signal: 'Trait ' , t1 trait asString , ' already in composition'].
			nil].
	self addLast: t1! !

!TraitComposition methodsFor: 'converting' stamp: ''!
- t1 
	self addLast: self removeLast - t1! !

!TraitComposition methodsFor: 'converting' stamp: ''!
@ t1 
	self addLast: self removeLast @ t1! !

!TraitComposition methodsFor: 'accessing' stamp: ''!
allTraits
	^ self
		gather: [:t1 | t1 allTraits copyWith: t1 trait]! !

!TraitComposition methodsFor: 'converting' stamp: ''!
asTraitComposition
	^ self! !

!TraitComposition methodsFor: 'operations' stamp: ''!
copyTraitExpression
	^ self
		collect: [:t1 | t1 copyTraitExpression]! !

!TraitComposition methodsFor: 'operations' stamp: ''!
isAliasSelector: t1 
	^ self
		anySatisfy: [:t2 | t2 isAliasSelector: t1]! !

!TraitComposition methodsFor: 'operations' stamp: ''!
isLocalAliasSelector: t1 
	^ self
		anySatisfy: [:t2 | t2 isTraitTransformation
				and: [t2 isLocalAliasSelector: t1]]! !

!TraitComposition methodsFor: 'testing' stamp: ''!
isTraitTransformation
	^ false! !

!TraitComposition methodsFor: 'converting' stamp: ''!
printOn: t1 
	t1 nextPutAll: self traitCompositionString! !

!TraitComposition methodsFor: 'operations' stamp: ''!
selectorsAndMethodsDo: t1 
	self
		do: [:t2 | t2 selectorsAndMethodsDo: t1]! !

!TraitComposition methodsFor: 'operations' stamp: ''!
traitCompositionString
	self size = 0
		ifTrue: [^ '{}'].
	self size = 1
		ifTrue: [^ self first asString].
	^ String
		streamContents: [:t1 | self
				do: [:t2 | t1 nextPutAll: t2 asString]
				separatedBy: [t1 nextPutAll: ' + ']]! !

!TraitComposition methodsFor: 'accessing' stamp: ''!
traits
	^ Array
		streamContents: [:t1 | self
				traitsDo: [:t2 | t1 nextPut: t2]]! !

!TraitComposition methodsFor: 'accessing' stamp: ''!
traitsDo: t1 
	^ self
		do: [:t2 | t2 traitsDo: t1]! !
Trait initialize!
